#!/bin/bash

# set -x

#Update Permissions for hydrocontrol user
echo "Refreshing Permissions"
chown -R hydrocontrol /home/hydrocontrol/hydrocontrol/

# WebAPI Service
# echo "Stopping WebAPI Service"
# systemctl stop hydrocontrol-webapi.service
echo "Backup Database"
mkdir -p /home/hydrocontrol/backups
cp -r /var/www/hydrocontrol/hydrocontrol.webapi/*.db /home/hydrocontrol/backups
echo "Remove WebAPI Files"
rm -r /var/www/hydrocontrol/hydrocontrol.webapi/*
echo "Make Application Executable"
chmod +x /home/hydrocontrol/hydrocontrol/hydrocontrol.webapi/HydroControl.WebAPI
echo "Copy files to web container"
cp -r /home/hydrocontrol/hydrocontrol/hydrocontrol.webapi/* /var/www/hydrocontrol/hydrocontrol.webapi
echo "Update Permissions for new files"
chgrp -R  www-data /var/www/hydrocontrol/hydrocontrol.webapi/
chmod 775  /var/www/hydrocontrol/hydrocontrol.webapi/
chmod u+x  /var/www/hydrocontrol/hydrocontrol.webapi/Scripts/*.sh
dos2unix *.sh

# Update backup permissions for hydrocontrol user
chown -R hydrocontrol /home/hydrocontrol/backups/

# Restore Database Files
echo "Restoring Database Files"
cp -r /home/hydrocontrol/backups/*.db /var/www/hydrocontrol/hydrocontrol.webapi

# ClientApp Service
# echo "Stopping ClientApp Service"
# Systemctl stop hydrocontrol-clientapp.service
rm -r /var/www/hydrocontrol/hydrocontrol.clientapp/*
chmod +x /home/hydrocontrol/hydrocontrol/hydrocontrol.clientapp/HydroControl.ClientApp
cp -r /home/hydrocontrol/hydrocontrol/hydrocontrol.clientapp/* /var/www/hydrocontrol/hydrocontrol.clientapp
chgrp -R  www-data /var/www/hydrocontrol/hydrocontrol.clientapp/
chmod 775  /var/www/hydrocontrol/hydrocontrol.clientapp/

shutdown --reboot now
sleep 90