#!/bin/bash

# Custom update logic for version 1.1.0.0
# This can include copying new files, applying patches, modifying configuration files, etc.

echo "Applying update for version 1.1.0.0..."

# Add your update logic here

# Remove the HTTPS development certificate
dotnet dev-certs https --clean

# Path to the service file
SERVICE_FILE="/etc/systemd/system/hydrocontrol-clientapp.service"

# Lines to add
LINES="Requires=hydrocontrol-webapi.service\nAfter=hydrocontrol-webapi.service\nPartOf=hydrocontrol-webapi.service"

# Check if the lines are already in the file
grep -q "$LINES" $SERVICE_FILE

# If the lines are not found, insert them after the Description line
if [ $? -ne 0 ]; then
  sed -i "/Description=HydroControl Client App/a $LINES" $SERVICE_FILE

  # Reload systemd to apply the changes
  systemctl daemon-reload

  echo "Service file updated and service restarted."
else
  echo "Required lines are already in the service file."
fi

echo "Update for version 1.1.0.0 applied successfully."